<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><a href="<?= $this->url('timesheet') ?>"><?= $this->translate('time_module_title') ?></a></li>
    <li class="active"><?= $this->translate('timesheet_nav_synchronisation') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('refresh') ?> <?= $this->translate('timesheet_synchronisation_module_title') ?>
</h1>

<div class="row row-padding" ng-controller="synchronisationListController as self" ng-init='self.init(<?= json_encode($this->authStorage()->getUser()->getArray(), JSON_HEX_APOS) ?>)'>
    <div class="col-xs-12">
        <div class="panel">
            <table-builder options="self.options" items="self.timesheets" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('timesheet_nav_list_synchronisation') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('timesheet_run_checked_sync') ?>">
                            <?= $this->icon('import', 'fa-fw pointer', ['data-toggle' => 'modal', 'data-target' => '#modalTimeRange']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                            <?= $this->icon('eraser', 'fa-fw pointer', ['ng-click' => '__tb.removeFromList()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse"
                                             href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text"
                                               placeholder="<?= $this->translate('search', null, null, false) ?>"
                                               class="form-control"
                                               ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?php

                                    $typeOptions = [];
                                    foreach (Time\Entity\Synchronisation::getTypes() as $id => $type) {
                                        $typeOptions[] = [
                                            'value' => $id,
                                            'text'  => $type,
                                        ];
                                    }

                                    $filters = [
                                        'name' => [
                                            'label' => $this->translate('timesheet_synchronisation_field_name'),
                                            'type'  => 'string',
                                        ],
                                        'link' => [
                                            'label' => $this->translate('timesheet_synchronisation_field_link'),
                                            'type'  => 'string',
                                        ],
                                        'type' => [
                                            'label'   => $this->translate('timesheet_synchronisation_field_type'),
                                            'type'    => 'manytoone',
                                            'options' => $typeOptions,
                                        ],
                                    ];

                                    echo $this->tableFilter('__tb.apiParams.search.data.filters', $filters);
                                    ?>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn"
                                                    ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns ng-show="self.view == 'table'"></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <table table-builder-table class="table table-bordered table-condensed table-hover">
                                <thead>
                                    <tr>
                                        <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                        <th tb-column tb-name="name" tb-sortable="true" tb-toggle="true">
                                            <?= $this->translate('timesheet_synchronisation_field_name') ?>
                                        </th>
                                        <th tb-column tb-name="link" tb-sortable="true" tb-toggle="true">
                                            <?= $this->translate('timesheet_synchronisation_field_link') ?>
                                        </th>
                                        <th tb-column tb-name="type" tb-sortable="true" tb-toggle="true">
                                            <?= $this->translate('timesheet_synchronisation_field_type') ?>
                                        </th>
                                        <th tb-column tb-name="actions" class="actions-column"></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr ng-repeat="synchronisation in self.synchronisations" ng-class="{editing: self.editedLine == synchronisation}">
                                        <td><input type="checkbox" ng-model="synchronisation.selected"/></td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== synchronisation">
                                                <a ng-if="synchronisation._rights.read" href="<?= $this->url('timesheet/synchronisation/form') ?>/{{synchronisation.id}}">{{synchronisation.name}}</a>
                                                <span ng-if="!synchronisation._rights.read">{{synchronisation.name}}</span>

                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(synchronisation)', 'ng-if' => 'synchronisation._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == synchronisation">
                                                <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required />
                                                <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== synchronisation">
                                                {{synchronisation.link}}
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(synchronisation)', 'ng-if' => 'synchronisation._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == synchronisation">
                                                <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.link" required />
                                                <field-errors field="link" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td class="editable">
                                            <span ng-show="self.editedLine !== synchronisation">
                                                {{ 'timesheet_synchronisation_type_' + synchronisation.type | translate }}
                                                <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(synchronisation)', 'ng-if' => 'synchronisation._rights.update']) ?>
                                            </span>
                                            <span ng-if="self.editedLine == synchronisation">
                                                <select class="form-control input-sm"
                                                        name="type"
                                                        id="type"
                                                        required
                                                        ng-model="self.editedLineFields.type">
                                                    <?php foreach (Time\Entity\Synchronisation::getTypes() as $id => $type) {
                                                        echo "<option value='$id'>" . $type . "</option>";
                                                    } ?>
                                                </select>
                                                <field-errors field="type" errors="self.editedLineErrors"></field-errors>
                                            </span>
                                        </td>
                                        <td>
                                            <div class="btn-group btn-group-actions" ng-if="self.editedLine !== synchronisation">
                                                <?php if ($this->acl()->isAllowed('time:e:synchronisation:r')) : ?>
                                                    <a ng-if="synchronisation._rights.read"
                                                       href="<?= $this->url('timesheet/synchronisation/form') ?>/{{synchronisation.id}}"
                                                       class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                        <?= $this->icon('edit') ?>
                                                    </a>
                                                <?php endif; ?>

                                                <?php if ($this->acl()->isAllowed('time:e:synchronisation:d')) : ?>
                                                    <a ng-if="synchronisation._rights.delete"
                                                       href="#"
                                                       ng-click="self.deleteSynchronisation(synchronisation)"
                                                       class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
                                                        <?= $this->icon('delete') ?>
                                                    </a>
                                                <?php endif; ?>
                                            </div>
                                            <div class="btn-group btn-group-actions" ng-if="self.editedLine == synchronisation">
                                                <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(synchronisation)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                    <?= $this->icon('save') ?>
                                                </button>
                                                <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                    <?= $this->icon('close') ?>
                                                </button>
                                            </div>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </table-builder>
        </div>

        <div class="modal fade" id="modalTimeRange" tabindex="-1" role="dialog" aria-labelledby="modalTimeRangeLabel">
            <div class="modal-dialog" role="document">
                <div name="timeRangeForm" class="modal-content">
                    <div class="modal-header">
                        <h4 class="modal-title" id="modalTimeRangeLabel">
                            <?= $this->translate('timesheet_import_choose_time_range') ?>
                        </h4>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label
                                for="dateTimeStart"><?= $this->translate('timesheet_import_datetime_start'); ?></label>
                            <input type="datetime" id="dateTimeStart" ng-model="self.time.start" input-mask="qdate"
                                   class="form-control"/>
                        </div>
                        <div class="form-group">
                            <label for="dateTimeEnd"><?= $this->translate('timesheet_import_datetime_end'); ?></label>
                            <input type="datetime" id="dateTimeEnd" ng-model="self.time.end" input-mask="qdate"
                                   class="form-control"/>
                        </div>
                        <div class="form-group">
                            <label for="onBehalfUser"><?= $this->translate('timesheet_field_behalf_user'); ?></label>
                            <user-select id="onBehalfUser" name="onBehalfUser" ng-model="self.user" multiple="false" required="true"></user-select>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default pull-right" data-dismiss="modal">
                            <?= $this->translate('close') ?>
                        </button>
                        <button type="button" class="btn btn-submit pull-left" data-dismiss="modal"
                                ng-click="self.import()">
                            <?= $this->translate('synchronize') ?>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('time:e:synchronisation:c')) {
    $fabLinks[] = [
        'href' => $this->url('timesheet/synchronisation/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('timesheet_synchronisation_nav_form'),
    ];
    $fabLinks[] = [
        'href' => $this->url('timesheet/synchronisation/import', [], ['query' => ['ics' => 'true']]),
        'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('timesheet_nav_import_ics')
    ];
}

echo $this->fabMenu($fabLinks);

$this->angular('js/src/user/directive/userSelect.js');
$this->angular('js/src/project/directive/projectSelect.js');

$this->angular('js/src/keyword/service/keyword.js');
$this->angular('js/src/time/service/synchronisation.js');
$this->angular('js/src/application/query/service/query.js');
$this->angular('js/src/project/service/project.js');
$this->angular('js/src/user/service/user.js');

$this->angular('js/src/time/controller/synchronisation/list.js');
